//--------------------------------------------------------------------//
// nV

var canvas;				// LoXvf
var context;	 			// ReLXg
var pressed;				// }EX{^
var mx,my;				// }EXʒu
var cx,cy;				// ʒSʒu
var sa;					// _px
var list=[];				// Cݐf[^Xg
var capitals=[],cities=[];		// sEssXg
var viewMode;				// \[h
var radius,radiusMax,radiusMin;		// nVaEőlEŏl
var thetaX;				// _px
var ecpX,ecpY;				// ~}@[ȟox/ܓxWϊW
var coefX1,coefX2,coefY;		// _ړxinVoxCECPoxCnVܓxj
var pName,pColor;			// ss|C^ ssE\F

// n\[h
var GLOBE=0;				// nV[h
var ECP=1;				// ~}@[h

// \F
var FG_COLOR='rgb(0,0,0)';		// OiF
var BG_COLOR='rgb(255,255,255)';	// wiF
var CAPITAL_COLOR='rgb(255,0,0)';	// s\F
var CITY_COLOR='rgb(0,0,255)';		// ss\F

var RECT=3,RH=parseInt(RECT/2);		// ss}[N\TCY
var RADIUS_COEF=1.2;			// gEk
var FONT_SIZE=14;			// tHgTCY
var TO_RADIAN=Math.PI/180.0;		// pxWAɕϊW
var THETA_X=15.0,THETA_Y=10.0;		// _oxEܓxω

// nV
// mapFileName - Cݐf[^t@C
// cityFileName - ssf[^t@C
function initGlobe(mapFileName,cityFileName){
  initCanvas();
  readDataFile(mapFileName,readMapData);
  readDataFile(cityFileName,readCityData);
  setMode();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('globe');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  canvas.addEventListener('mousemove',mouseMoved,false);
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  context.strokeStyle=FG_COLOR;
  context.font=FONT_SIZE+"px 'Arial'";
  pressed=false;
  mx=0;
  my=0;
  cx=canvas.width/2;
  cy=canvas.height/2;
  radius=parseInt(0.8*Math.min(cx,cy));
  radiusMax=10*radius;
  radiusMin=radius;
  coefX1=144/canvas.width;
  coefY=144/canvas.height;
  coefX2=360/canvas.width;
  ecpX=cx/180.0;
  ecpY=Math.min(cx,2*cy)/180.0;
  sa=new SphericalAngle();
  sa.set(Math.PI*135/180,0.0);
  thetaX=135.0;
  pName=null;
  pColor=null;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  var rect=e.target.getBoundingClientRect();
  setPointer(mx-rect.left,my-rect.top);
  draw();
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// }EX{^ړ̏s
function mouseMoved(e){
  if(pressed){
    rotate(mx-e.clientX,e.clientY-my);
    mx=e.clientX;
    my=e.clientY;
    draw();
  }
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 37:		// (Numpad4 Off)
    case 65:		// A
    case 100:		// Numpad4 On
      rotate(THETA_X,0);
      draw();
      break;
    case 39:		// E(Numpad6 Off)
    case 70:		// F
    case 102:		// Numpad6 On
      rotate(-THETA_X,0);
      draw();
      break;
    case 40:		// (Numpad2 Off)
    case 68:		// D
    case 98:		// Numpad2 On
      rotate(0,THETA_Y);
      draw();
      break;
    case 38:		// (Numpad8 Off)
    case 83:		// S
    case 104:		// Numpad8 On
      rotate(0,-THETA_Y);
      draw();
      break;
    case 12:		// (Numpad5 Off)
    case 53:		// 5
    case 67:		// C
    case 101:		// Numpad5 On
      if(viewMode==GLOBE){
      	viewMode=ECP;
      }
      else{
      	viewMode=GLOBE;
      }
      draw();
      break;
    case 35:		// End(Numpad1 Off)
    case 49:		// 1
    case 97:		// Numpad1 On
    case 107:		// Numpad+
    case 187:		// +
      zoomin();
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 96:		// Numpad0 On
    case 109:		// Numpad-
    case 189:		// -
      zoomout();
      break;
  }
}

// f[^t@Cǂݍ
// fileName - f[^t@C
// func - ǂݍ݊֐
function readDataFile(fileName,func){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      func(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// Cݐf[^t@Cǂݍ
// s - f[^̃Xg
function readMapData(s){
  list.length=0;
  var row=0,mm=-1,aa=0,bb=0,name="",area=0,block=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g," ").split(/\s+/);
    if(ss.length>=2){
      var p=new Point(Number(ss[0]),Number(ss[1]));
      if(block>0){
      	list[mm][aa][bb]=p;
      	bb++;
      	if(bb==block){
      	  block=0;
      	  if(aa+1==area){
      	    area=0;
      	  }
      	}
      }
    }
    else if(ss.length==1){
      if(isNaN(ss[0])){
      	name=ss[0];
      }
      else if(ss[0]===''){
      }
      else if(area===0){
      	area=parseInt(ss[0]);
      	mm++;
      	list[mm]=[];
      	aa=-1;
      }
      else{
      	block=parseInt(ss[0]);
      	aa++;
      	list[mm][aa]=[];
      	bb=0;
      }
    }
    row++;
  }
}

// ssf[^t@Cǂݍ
// s - f[^̃Xg
function readCityData(s){
  capitals.length=0;
  cities.length=0;
  var row=0,name="",isCapital=true;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g," ").split(/\s+/);
    if(ss.length>=2){
      var city=new City(name,Number(ss[0]),Number(ss[1]));
      if(isCapital){
      	capitals.push(city);
      }
      else{
      	cities.push(city);
      }
    }
    else if(ss.length==1){
      var keyWord=ss[0].toLowerCase();
      if(keyWord=="capital"){
      	isCapital=true;
      }
      else if(keyWord=="city"){
      	isCapital=false;
      }
      else if(ss[0]!==''){
      	name=ss[0];
      }
    }
    row++;
  }
}

// ss|C^ݒ肷
// x,y - }EXʒu
function setPointer(x,y){
  for(var i=0;i<capitals.length;i++){
    if(capitals[i].click(x,y)){
      pName=capitals[i].name;
      pColor=CAPITAL_COLOR;
      return;
    }
  }
  for(i=0;i<cities.length;i++){
    if(cities[i].click(x,y)){
      pName=cities[i].name;
      pColor=CITY_COLOR;
      return;
    }
  }
  pName=null;
  pColor=null;
}

// gEk
// coef - ågEkW
function zoom(coef){
  if(viewMode==GLOBE){
    radius=Math.max(Math.min(parseInt(coef*radius),radiusMax),
      	      	    radiusMin);
    draw();
  }
}

// _ʒu]
function rotate(dx,dy){
  switch(viewMode){
    case GLOBE:
      rotateMap(coefX1*dx,coefY*dy);
      break;
    case ECP:
      rotateMap(coefX2*dx,0.0);
      break;
  }
}

// _ʒu]
// dx,dy - x,yWړ
function rotateMap(dx,dy){
  thetaX+=dx;
  if(thetaX>180)       thetaX-=360;
  else if(thetaX<-180) thetaX+=360;
  sa.rotate(TO_RADIAN*dx,TO_RADIAN*dy);
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  switch(viewMode){
    case GLOBE:
      drawGlobe();
      break;
    case ECP:
      drawECP();
      break;
  }
  if(pName!==null){
    var metrix=context.measureText(pName);
    context.fillStyle=pColor;
    context.fillText(pName,canvas.width-metrix.width-2,FONT_SIZE);
  }
}

// `悷 (nV[h)
function drawGlobe(){
  context.beginPath();
  context.arc(cx,cy,radius,0,2*Math.PI,false);
  for(var i=0;i<list.length;i++){
    for(var j=0;j<list[i].length;j++){
      var p=list[i][j];
      var prevp=p[0].getGlobe();
      context.moveTo(prevp.x,prevp.y);
      for(var k=1;k<p.length;k++){
      	var vp=p[k].getGlobe();
      	if((prevp.z>=0) && (vp.z>=0)){
      	  context.lineTo(vp.x,vp.y);
      	}
      	else{
      	  context.moveTo(vp.x,vp.y);
      	}
      	prevp=vp;
      }
    }
  }
  context.closePath();
  context.stroke();

  context.fillStyle=CAPITAL_COLOR;
  for(i=0;i<capitals.length;i++){
    capitals[i].getGlobe();
    capitals[i].draw();
  }
  context.fillStyle=CITY_COLOR;
  for(i=0;i<cities.length;i++){
    cities[i].getGlobe();
    cities[i].draw();
  }
}

// `悷 (~}@[h)
function drawECP(){
  var border1=cy-parseInt(90.0*ecpY);
  var border2=cy+parseInt(90.0*ecpY);
  context.beginPath();
  context.moveTo(0,border1);
  context.lineTo(2*cx,border1);
  context.moveTo(0,border2);
  context.lineTo(2*cx,border2);
  for(var i=0;i<list.length;i++){
    for(var j=0;j<list[i].length;j++){
      var p=list[i][j];
      var prevp=p[0].getECP();
      context.moveTo(prevp.x,prevp.y);
      for(var k=1;k<p.length;k++){
      	var vp=p[k].getECP();
      	if(Math.abs(prevp.x-vp.x)<=cx){
      	  context.lineTo(vp.x,vp.y);
      	}
      	else{
      	  context.moveTo(vp.x,vp.y);
      	}
      	prevp=vp;
      }
    }
  }
  context.closePath();
  context.stroke();

  context.fillStyle=CAPITAL_COLOR;
  for(i=0;i<capitals.length;i++){
    capitals[i].getECP();
    capitals[i].draw();
  }
  context.fillStyle=CITY_COLOR;
  for(i=0;i<cities.length;i++){
    cities[i].getECP();
    cities[i].draw();
  }
}

// \g傷
function zoomin(){
  zoom(RADIUS_COEF);
}

// \k
function zoomout(){
  zoom(1.0/RADIUS_COEF);
}

// \[hݒ肷
function setMode(){
  var mode=document.getElementById('mode').value;
  if(mode=='globe'){
    viewMode=GLOBE;
  }
  else{
    viewMode=ECP;
  }
  draw();
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// ̓_
// x - ox
// y - ܓx
var Point=function(x,y){
  this.x=x;
  this.y=y;
  var rx=TO_RADIAN*x;
  var ry=TO_RADIAN*y;
  this.p=new Point3D(Math.cos(rx)*Math.cos(ry),
      	      	     Math.sin(rx)*Math.cos(ry),
      	      	     -Math.sin(ry));
  this.vp=new Point3D(0,0,0);
};

// nV̉ʏ3_Ԃ
// cx,cy - plS_
// radius - nV̕`攼a
// sa - _px
Point.prototype.getGlobe=function(){
  var tvp=this.p.clone();
  sa.rotatePoint(tvp);
  this.vp.set(parseInt(radius*tvp.x+cx),parseInt(radius*tvp.y+cy),
      	      parseInt(radius*tvp.z));
  return this.vp;
};

// ~}@̉ʏ3_Ԃ
Point.prototype.getECP=function(){
  var x2=this.x-thetaX;
  if(x2>180)       x2-=360;
  else if(x2<-180) x2+=360;
  this.vp.set(parseInt(ecpX*x2+cx),parseInt(-ecpY*this.y+cy),1);
  return this.vp;
};

//--------------------------------------------------------------------//
// ssf[^
// name - ss
// x - ox
// y - ܓx
var City=function(name,x,y){
  Point.call(this,x,y);
  this.name=name;
};

// NbN𔻒肷
// x,y - }EXʒu
City.prototype.click=function(x,y){
  if(this.vp.z>=0){
    return ((this.vp.x-RECT<=x) && (x<=this.vp.x+RECT)
      	 && (this.vp.y-RECT<=y) && (y<=this.vp.y+RECT));
  }
  else{
    return false;
  }
};

// ss`悷
City.prototype.draw=function(){
  if(this.vp.z>=0){
    context.fillRect(this.vp.x-RH,this.vp.y-RH,RECT,RECT);
  }
};

//--------------------------------------------------------------------//
// Wpx
var SphericalAngle=function(){
  this.theta=0.0;
  this.phy=0.0;
  this.stheta=0.0;
  this.ctheta=1.0;
  this.sphy=0.0;
  this.cphy=1.0;
};

// pxݒ肷
// theta,phy - ,
SphericalAngle.prototype.set=function(theta,phy){
  while(theta<-Math.PI) theta+=2.0*Math.PI;
  while(theta>Math.PI) theta-=2.0*Math.PI;
  this.theta=theta;
  this.phy=Math.min(Math.max(phy,-0.5*Math.PI),0.5*Math.PI);
  this.stheta=Math.sin(this.theta);
  this.ctheta=Math.cos(this.theta);
  this.sphy=Math.sin(this.phy);
  this.cphy=Math.cos(this.phy);
};

// px]
SphericalAngle.prototype.rotate=function(dtheta,dphy){
  this.set(this.theta+dtheta,this.phy+dphy);
};

// _]
// p ]_
SphericalAngle.prototype.rotatePoint=function(p){
  var temp=this.ctheta*p.x+this.stheta*p.y;
  var x=-this.stheta*p.x+this.ctheta*p.y;
  var y=this.sphy*temp+this.cphy*p.z;
  var z=this.cphy*temp-this.sphy*p.z;
  p.set(x,y,z);
};

//--------------------------------------------------------------------//
// 3_
// x,y,z - x,y,zW
var Point3D=function(x,y,z){
  this.x=x;
  this.y=y;
  this.z=z;
};

// _̍Wݒ肷
// x,y,z - x,y,zW
Point3D.prototype.set=function(x,y,z){
  this.x=x;
  this.y=y;
  this.z=z;
};

// _Ƃ̋Ԃ
// p - 𑪂Ώۂ̓_
Point3D.prototype.distance=function(p){
  var dx=this.x-p.x;
  var dy=this.y-p.y;
  var dz=this.z-p.z;
  return Math.sqrt(dx*dx+dy*dy+dz*dz);
};

// _̃Rs[Ԃ
Point3D.prototype.clone=function(){
  return new this.constructor(this.x,this.y,this.z);
};

inherits(City,Point);
